//+---------------------------------------------------------------------+ 
//|                                                        NavelEMA.mq5 | 
//|                                        Copyright  2008, Bookkeeper |
//|                                                yuzefovich@gmail.com | 
//+---------------------------------------------------------------------+ 
//|          SmoothAlgorithms.mqh |
//|   (): __\\MQL5\Include        |
//+---------------------------------------------------------------------+ 
#property copyright "Copyright  2008, Bookkeeper"
#property link "yuzefovich@gmail.com" 
//----   
#property version   "1.00"
#property description " EMA       "
#property description "  : NavelEMA = EMA( ( close*5 + open*2 + high + low ) / 9 )."
//----     
#property indicator_chart_window 
//----   
#property indicator_buffers 1 
//----     
#property indicator_plots   1
//+-----------------------------------+
//|       |
//+-----------------------------------+
//----     
#property indicator_type1   DRAW_LINE
//----        MediumOrchid 
#property indicator_color1 clrMediumOrchid
//----   -  
#property indicator_style1  STYLE_SOLID
//----     2
#property indicator_width1 2
//----   
#property indicator_label1  "NavelEMA"
//+-----------------------------------+
//|         |
//+-----------------------------------+
input double EmaLength=12.75; //                     
input int Shift=0; //      
input int PriceShift=0; // c     
//+-----------------------------------+
//----  
double EMABuffer[];
double dPriceShift;
//----   
int min_rates_total;
//+------------------------------------------------------------------+
//   CMoving_Average                                   |
//+------------------------------------------------------------------+
#include <SmoothAlgorithms.mqh> 
//+------------------------------------------------------------------+    
//| EMA indicator initialization function                            | 
//+------------------------------------------------------------------+  
void OnInit()
  {
//----     
   min_rates_total=2;
//----      
   SetIndexBuffer(0,EMABuffer,INDICATOR_DATA);
//----       Shift
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//----      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----      
   string shortname;
   StringConcatenate(shortname,"NavelEMA( Length = ",EmaLength,")");
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
//----    
   dPriceShift=_Point*PriceShift;
//----  
  }
//+------------------------------------------------------------------+  
//| EMA iteration function                                           | 
//+------------------------------------------------------------------+  
int OnCalculate(
                const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double& high[],     //       
                const double& low[],      //        
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]
                )
  {
//----       
   if(rates_total<min_rates_total) return(0);

//----   
   int first,bar;
   double series,ema;

   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      first=0; //      
     }
   else first=prev_calculated-min_rates_total; //      

//----    CMoving_Average   SmoothAlgorithms.mqh 
   static CMoving_Average EMA;

//----    
   for(bar=first; bar<rates_total; bar++)
     {
      series=(close[bar]*5+open[bar]*2+high[bar]+low[bar])/9;
      ema=EMA.EMASeries(0,prev_calculated,rates_total,EmaLength,series,bar,false);      
      EMABuffer[bar]=ema+dPriceShift;
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
